const utils = require('./utils');

const width = 100;
const fullChar = '=';
const emptyChar = '-';

const show = (percent, speed) => {
    process.stderr.clearLine(-1);
    process.stderr.write('\r');
    const doneCount = parseInt(width * percent);
    let progressBar = '[';

    for (let i = 0; i < doneCount; i++) {
        progressBar += fullChar;
    }
    for (let i = 0; i < width - doneCount; i++) {
        progressBar += emptyChar;
    }

    const speedStr = utils.getSpeedByBytes(speed);
    progressBar += `]  ${parseInt(percent * 100)}%  ${speedStr}`;
    process.stderr.write(progressBar);
};

const showPer = (percent) => {
    process.stderr.clearLine(-1);
    process.stderr.write('\r');
    const doneCount = parseInt(width * percent);
    let progressBar = '[';

    for (let i = 0; i < doneCount; i++) {
        progressBar += fullChar;
    }
    for (let i = 0; i < width - doneCount; i++) {
        progressBar += emptyChar;
    }

    progressBar += `]  ${parseInt(percent * 100)}%`;
    process.stderr.write(progressBar);
};

const done = () => {
    process.stderr.clearLine(-1);
    process.stderr.write('\r');
    let progressBar = '[';
    for (let i = 0; i < width; i++) {
        progressBar += fullChar;
    }
    progressBar += ']  100%';
    process.stderr.write(progressBar);
    console.log('\n');
};

module.exports = {
    show,
    showPer,
    done
};