const fse = require('fs-extra');
const cheerio = require('cheerio');
const request = require('request');
const path = require('path');
const _ = require('lodash');

const log = require('../libs/log');
const downloader = require('../libs/downloader');


const baseUrl = 'https://www.pornhub.com';
const baseReqOpts = {
    headers: {
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
        'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.100 Safari/537.36'
    }
};

const crawlMainpage = (config) => {
    crawlVideos(config, {
        url: baseUrl,
        qs: {}
    })
}

const crawlSearch = (config) => {
    crawlVideos(config, {
        baseUrl: baseUrl,
        uri: '/video/search',
        qs: { search: encodeURI(config.search.trim()) }
    })
}

const crawlCategory = (config) => {
    crawlVideos(config, {
        baseUrl: baseUrl,
        uri: '/video',
        qs: { c: encodeURI(config.category.trim()) }
    })
}

const crawlVideos = async(config, reqOpts) => {
    try {
        let page = 1;
        while (true) {
            if (page > 1) reqOpts.qs.page = page;
            Object.assign(reqOpts, baseReqOpts);
            const keys = await getVideoKeys(reqOpts);
            if (!keys || keys.length === 0) {
                throw new Error('find nothing!');
            }
            for (const key of keys) {
                const msg = await crawlVideoPage(key, config.downloadDir, config.proxy);
                log.verbose(msg);
                console.log('');
            }
            page += 1;
        }
    } catch (error) {
        console.log(error);
        process.exit(0);
    }
}

const getVideoKeys = (opts) => {
    return new Promise((resolve, reject) => {
        request(opts, (err, res, body) => {
            if (err) {
                reject(err);
                return;
            }
            const $ = cheerio.load(body);
            const allKeys = [];
            $('.videoblock.videoBox').each((idx, element) => {
                const key = element.attribs['_vkey'];
                allKeys.push(key);
            });
            const skipKeys = [];
            $('.dropdownHottestVideos .videoblock.videoBox').each((idx, element) => {
                const key = element.attribs['_vkey'];
                skipKeys.push(key);
            });
            $('.dropdownReccomendedVideos .videoblock.videoBox').each((idx, element) => {
                const key = element.attribs['_vkey'];
                skipKeys.push(key);
            });
            const keys = [];
            allKeys.forEach(k => {
                if (-1 === skipKeys.indexOf(k)) {
                    keys.push(k);
                }
            });
            resolve(keys);
        })
    });
}

const crawlVideoPage = (key, downloadDir, proxy) => {
    return new Promise((resolve, reject) => {
        downloadVideo(key).then(
            videoInfo => {
                downloader.download(
                    videoInfo.key,
                    `${videoInfo.title}_${videoInfo.quality}P_${videoInfo.key}.${videoInfo.format}`,
                    downloadDir,
                    videoInfo.videoUrl,
                    proxy
                ).then(
                    (msg) => resolve(msg),
                    (errs) => reject(errs)
                );
            },
            err => reject(err)
        );
    });
}

const downloadVideo = (key) => {
    let opts = {
        url: `https://www.pornhub.com/view_video.php?viewkey=${key}`,
    };
    Object.assign(opts, baseReqOpts);
    return new Promise((resolve, reject) => {
        request(opts, (err, res, body) => {
            if (err) {
                reject(err);
            }
            const videoInfo = parseDownloadInfo(body);
            if (videoInfo) {
                videoInfo.key = key;
                resolve(videoInfo);
            } else {
                reject("FAILED: Can't find any video info.");
            }
        });
    })
}

const parseDownloadInfo = (bodyStr) => {
    const index = bodyStr.indexOf('mediaDefinitions');
    if (index < 0) {
        return undefined;
    }
    let begin, end;
    for (let i = index; i < bodyStr.length; i++) {
        const tmpStr = bodyStr.substr(i, 1);
        if (tmpStr === '[') {
            begin = i;
        }
        if (tmpStr === ']') {
            end = i;
            break;
        }
    }
    let info;
    if (begin >= 0 && end >= 0) {
        let arr = JSON.parse(bodyStr.substring(begin, end + 1));
        arr = _.filter(arr, item => item.videoUrl.length > 0)
        arr = _.orderBy(arr, 'quality', 'desc');
        if (arr.length > 0) {
            info = arr[0];
            info.title = findTitle(bodyStr);
        }
    }
    return info;
};

const findTitle = (bodyStr) => {
    const $ = cheerio.load(bodyStr);
    const title = $('title').text();
    const arr = title.split('-');
    arr.pop();
    return arr.join('-').trim();
};

const start = (config) => {
    if (config.proxy !== undefined) {
        baseReqOpts.proxy = config.proxy;
    }
    if (!fse.existsSync(config.downloadDir)) {
        fse.mkdirpSync(config.downloadDir);
    }
    if (config.key !== undefined) {
        crawlVideoPage(config.key, config.downloadDir, config.proxy).then(
            msg => {
                log.verbose(msg);
                process.exit(0);
            },
            errs => {
                log.error(errs);
                process.exit(0);
            }
        );
    } else if (config.search !== undefined) {
        crawlSearch(config);
    } else if (config.category !== undefined) {
        crawlCategory(config);
    } else {
        crawlMainpage(config);
    }
};

module.exports = {
    start
};